// AccessEase.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "AllMyIncludes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAccessEaseApp

BEGIN_MESSAGE_MAP(CAccessEaseApp, CWinApp)
	//{{AFX_MSG_MAP(CAccessEaseApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(IDC_FILE_OPEN_MRU, OnFileOpenMru)
	ON_UPDATE_COMMAND_UI(IDC_FILE_OPEN_MRU, OnUpdateFileOpenMru)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAccessEaseApp construction

CAccessEaseApp::CAccessEaseApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	m_strEncryptionPswd = _T("");
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CAccessEaseApp object

CAccessEaseApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CAccessEaseApp initialization

BOOL CAccessEaseApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(IDS_APP_REG_KEY);

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// get persistent data from registry
	m_bPswdMixedCase			= GetProfileInt(_settings, _bMixedCase, TRUE);
  	m_bPswdNumbers				= GetProfileInt(_settings, _bNumbers, TRUE);
 	m_bPswdPuncuation			= GetProfileInt(_settings, _bPuncuation, TRUE);
	m_bOpenMRU					= GetProfileInt(_settings, _bOpenMRU, FALSE);
	m_nPswdLength				= GetProfileInt(_settings, _nLength, DFLT_PSWD_LEN);
	m_bHideSitePswd				= GetProfileInt(_settings, _bHidePswd, TRUE);

	m_strLastSiteName			= GetProfileString(_settings, _strSiteName, _T(""));
	m_strFind					= GetProfileString(_settings, _strFind, _T(""));

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CAccessEaseDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CAccessEaseView));
	AddDocTemplate(pDocTemplate);

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// Restore the document at the top of the MRU list
	// 1 - Only if no command-line argument
	if(m_bOpenMRU && cmdInfo.m_nShellCommand == CCommandLineInfo::FileNew || 
	   cmdInfo.m_nShellCommand == CCommandLineInfo::FileNothing)
	{
		// 2 - Make sure that there is a MRU list
		if(m_pRecentFileList != NULL)
		{
			CString strMRU = (* m_pRecentFileList)[0];

			// 3 - Verify that the first MRU string is valid
			if(!strMRU.IsEmpty())
			{
				// 4 - Open this document file
				OpenDocumentFile(strMRU);
			}
		}
	}
	else // 5 - Perform standard command-line processing
	{
		// Dispatch commands specified on the command line
		if (!ProcessShellCommand(cmdInfo))
		{
			return FALSE;
		}
	}

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CBitmapButton	m_emailButton;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	afx_msg void OnEmailBtn();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_EMAIL_BTN, m_emailButton);
	//}}AFX_DATA_MAP
}

void CAboutDlg::OnEmailBtn() 
{
	CString url(MAIL2);
	url += MY_EMAIL_URL;
	url += SUBJECT;
	
	if((UINT)ShellExecute(NULL, _T("open"), url, NULL, NULL, SW_NORMAL) <= HINSTANCE_ERROR)
	{
		AfxMessageBox(IDS_MAIL_PROBLEM, MB_ICONERROR);
	}
	
	return;
}

BOOL CAboutDlg::OnInitDialog() 
{
	m_emailButton.AutoLoad(IDC_EMAIL_BTN, this);

	CDialog::OnInitDialog();
		
    // add icon to dialog
	HICON hicon = P_APP->LoadIcon(IDR_MAINFRAME);
	ASSERT(hicon);
	SetIcon(hicon, TRUE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_EMAIL_BTN, OnEmailBtn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CAccessEaseApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CAccessEaseApp message handlers


int CAccessEaseApp::ExitInstance() 
{
	// Save persistent data to registry
	WriteProfileInt(_settings, _bMixedCase, m_bPswdMixedCase);
	WriteProfileInt(_settings, _bNumbers, m_bPswdNumbers);
	WriteProfileInt(_settings, _bPuncuation, m_bPswdPuncuation);
	WriteProfileInt(_settings, _bOpenMRU, m_bOpenMRU);
	WriteProfileInt(_settings, _nLength, m_nPswdLength);
	WriteProfileInt(_settings, _bHidePswd, m_bHideSitePswd);

	WriteProfileString(_settings, _strSiteName, m_strLastSiteName);
	WriteProfileString(_settings, _strFind, m_strFind);
		
	return CWinApp::ExitInstance();
}

void CAccessEaseApp::OnFileOpenMru() 
{
	m_bOpenMRU = !m_bOpenMRU;	
}

void CAccessEaseApp::OnUpdateFileOpenMru(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_bOpenMRU);
}

