// AccessEaseView.cpp : implementation of the CAccessEaseView class
//

#include "stdafx.h"
#include "AllMyIncludes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAccessEaseView

IMPLEMENT_DYNCREATE(CAccessEaseView, CFormView)

BEGIN_MESSAGE_MAP(CAccessEaseView, CFormView)
	//{{AFX_MSG_MAP(CAccessEaseView)
	ON_COMMAND(IDC_HELP_DOC, OnHelpDoc)
	ON_COMMAND(ID_EDIT_ADD_SITE, OnEditAddSite)
	ON_UPDATE_COMMAND_UI(ID_EDIT_ADD_SITE, OnUpdateEditAddSite)
	ON_BN_CLICKED(IDC_BUTTON_ADD_SITE, OnButtonAddSite)
	ON_COMMAND(ID_EDIT_CANCEL_SITE, OnEditCancelSite)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CANCEL_SITE, OnUpdateEditCancelSite)
	ON_BN_CLICKED(IDC_BUTTON_CANCEL_SITE, OnButtonCancelSite)
	ON_COMMAND(ID_EDIT_EDIT_SITE, OnEditEditSite)
	ON_UPDATE_COMMAND_UI(ID_EDIT_EDIT_SITE, OnUpdateEditEditSite)
	ON_BN_CLICKED(IDC_BUTTON_EDIT_SITE, OnButtonEditSite)
	ON_CBN_DROPDOWN(IDC_COMBO_SITE, OnDropdownComboSite)
	ON_CBN_SELCHANGE(IDC_COMBO_SITE, OnSelchangeComboSite)
	ON_COMMAND(ID_EDIT_KEEP_SITE, OnEditKeepSite)
	ON_UPDATE_COMMAND_UI(ID_EDIT_KEEP_SITE, OnUpdateEditKeepSite)
	ON_BN_CLICKED(IDC_BUTTON_KEEP_SITE, OnButtonKeepSite)
	ON_COMMAND(ID_EDIT_REMOVE_SITE, OnEditRemoveSite)
	ON_UPDATE_COMMAND_UI(ID_EDIT_REMOVE_SITE, OnUpdateEditRemoveSite)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE_SITE, OnButtonRemoveSite)
	ON_COMMAND(ID_EDIT_GO_TO_SITE, OnEditGoToSite)
	ON_UPDATE_COMMAND_UI(ID_EDIT_GO_TO_SITE, OnUpdateEditGoToSite)
	ON_BN_CLICKED(IDC_BUTTON_GO_TO_SITE, OnButtonGoToSite)
	ON_BN_CLICKED(IDC_BUTTON_NOTES_SITE, OnButtonNotesSite)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT, OnUpdateFilePrint)
	ON_UPDATE_COMMAND_UI(ID_FILE_PRINT_PREVIEW, OnUpdateFilePrintPreview)
	ON_EN_KILLFOCUS(IDC_EDIT_PSWD_SITE, OnKillfocusEditPswdSite)
	ON_WM_TIMER()
	ON_COMMAND(ID_EDIT_FIND, OnEditFind)
	ON_UPDATE_COMMAND_UI(ID_EDIT_FIND, OnUpdateEditFind)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CUT, OnUpdateEditCut)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	ON_BN_CLICKED(IDC_BUTTON_FIND, OnEditFind)
	ON_COMMAND(ID_EDIT_NOTES, OnEditNotes)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_SITES, OnUpdateNumSites)
	ON_MESSAGE(WM_CLOSE_DROPDOWN, CloseDropDown)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAccessEaseView construction/destruction

CAccessEaseView::CAccessEaseView()
	: CFormView(CAccessEaseView::IDD)
{
	//{{AFX_DATA_INIT(CAccessEaseView)
	m_strNotesSite = _T("");
	m_strPswdSite = _T("");
	m_strUrlSite = _T("");
	m_strUserSite = _T("");
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	m_nIndexLastComboBoxSite = -1; // incicates no last site
}

CAccessEaseView::~CAccessEaseView()
{
}

void CAccessEaseView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAccessEaseView)
	DDX_Control(pDX, IDC_COMBO_SITE, m_comboBoxSite);
	DDX_Text(pDX, IDC_EDIT_NOTES_SITE, m_strNotesSite);
	DDX_Text(pDX, IDC_EDIT_PSWD_SITE, m_strPswdSite);
	DDX_Text(pDX, IDC_EDIT_URL_SITE, m_strUrlSite);
	DDX_Text(pDX, IDC_EDIT_USER_SITE, m_strUserSite);
	//}}AFX_DATA_MAP
}

BOOL CAccessEaseView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CAccessEaseView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

	m_comboBoxSite.ResetContent();

	int nSites = GetDocument()->m_sitePtrArray.GetSize();

	if(nSites > 0)	// set site data
	{
		for(int i = 0; i < nSites; i++)
		{
			CSiteInfo * pSite = (CSiteInfo *)(GetDocument()->m_sitePtrArray[i]);
			ASSERT(pSite);
			int index = m_comboBoxSite.AddString(pSite->m_strSite);
			m_comboBoxSite.SetItemData(index, (DWORD)pSite);
		}

		m_nIndexLastComboBoxSite = 0;
		// go to last site if possible
		CString aStr;

		for(i = 0; i < nSites; i++)
		{
			m_comboBoxSite.GetLBText(i, aStr);
			aStr.TrimRight();
 			aStr.TrimLeft();

			if(P_APP->m_strLastSiteName.Find(aStr, 0) >= 0)
			{
				m_nIndexLastComboBoxSite = i;
				break;
			}
		}

		m_comboBoxSite.SetCurSel(m_nIndexLastComboBoxSite);
		OnSelchangeComboSite();

		SetReadOnly(TRUE);
		m_bEditingSite = FALSE;
	}
	else // clear site
	{
		m_nIndexLastComboBoxSite = -1;
		ClearSite();
		SetReadOnly(FALSE);
		m_bEditingSite = TRUE;
	}

	UpdateData(FALSE);
}

void CAccessEaseView::ClearSite()
{
	m_comboBoxSite.SetWindowText(_T(""));
	m_strUrlSite = _T("");
	m_strUserSite = _T("");
	m_strPswdSite = _T("");
	m_strNotesSite = _T("");
	UpdateData(FALSE);
}

void CAccessEaseView::RestoreSite(int index)
{
	if(m_comboBoxSite.GetCount() > 0 && index >= 0 && index < m_comboBoxSite.GetCount())
	{
		m_comboBoxSite.SetCurSel(index);
		CSiteInfo * pSite = (CSiteInfo *)m_comboBoxSite.GetItemData(index);
		m_strUrlSite = pSite->m_strUrlSite;
		m_strUserSite = pSite->m_strUserSite;
		m_strPswdSite = pSite->m_strPswdSite;
		m_strNotesSite = pSite->m_strNotesSite;
		UpdateData(FALSE);
	}
}
/////////////////////////////////////////////////////////////////////////////
// CAccessEaseView printing

BOOL CAccessEaseView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CAccessEaseView::OnBeginPrinting(CDC* pDC, CPrintInfo* /*pInfo*/)
{
}

void CAccessEaseView::OnEndPrinting(CDC* pDC, CPrintInfo* /*pInfo*/)
{
}

void CAccessEaseView::OnPrint(CDC* pDC, CPrintInfo* /*pInfo*/)
{
	CFont printFont;
	printFont.CreatePointFont(10 * PRINT_PT_SIZE, _printFaceName, pDC);
	ASSERT_VALID(&printFont);
	CFont * pOldPrintFont = pDC->SelectObject(&printFont);
	TEXTMETRIC tm;
	pDC->GetTextMetrics(&tm);
	int charHeight = tm.tmHeight;
	int leftMargin = (int)(LEFT_MARGIN_INCH * pDC->GetDeviceCaps(LOGPIXELSX));
	int topMargin = (int)(TOP_MARGIN_INCH * pDC->GetDeviceCaps(LOGPIXELSY));
	int nScanLine = topMargin;
	CString aStr;

	m_comboBoxSite.GetLBText(m_nIndexLastComboBoxSite, aStr);
	pDC->TextOut(leftMargin, nScanLine, _T("Site:  ") + aStr);
	pDC->TextOut(leftMargin, nScanLine += charHeight, _T("URL:  ") + m_strUrlSite );
	pDC->TextOut(leftMargin, nScanLine += charHeight, _T("User:  ") + m_strUserSite);
	pDC->TextOut(leftMargin, nScanLine += charHeight, _T("Pswd:  ") + m_strPswdSite);
	nScanLine += charHeight;

	int nLen = m_strNotesSite.GetLength();

	aStr.Empty();

	for(int i = 0; i < nLen; i++)
	{
		if(m_strNotesSite[i] == _T('\t'))
		{
			aStr += _tabReplace;
		}
		else if(m_strNotesSite[i] != _T('\r') && m_strNotesSite[i] != _T('\n'))
		{
			aStr += m_strNotesSite[i];
		}
		else if(m_strNotesSite[i] == _T('\n'))
		{
			pDC->TextOut(leftMargin, nScanLine += charHeight, aStr);

			aStr.Empty();
		}
	}

	pDC->TextOut(leftMargin, nScanLine += charHeight, aStr);

	pDC->SelectObject(pOldPrintFont);
}

void CAccessEaseView::OnUpdateFilePrint(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_comboBoxSite.GetCount() > 0);	
}

void CAccessEaseView::OnUpdateFilePrintPreview(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_comboBoxSite.GetCount() > 0);	
}
/////////////////////////////////////////////////////////////////////////////
// CAccessEaseView diagnostics

#ifdef _DEBUG
void CAccessEaseView::AssertValid() const
{
	CFormView::AssertValid();
}

void CAccessEaseView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CAccessEaseDoc* CAccessEaseView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CAccessEaseDoc)));
	return (CAccessEaseDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAccessEaseView message handlers

// update status bar pane with number of sites
void CAccessEaseView::OnUpdateNumSites(CCmdUI* pCmdUI)
{
	CString aStr;
	aStr.Format(_T("\t%d Sites"), m_comboBoxSite.GetCount());
	pCmdUI->SetText(aStr);
}

// gray out (read only) site and all data windows
void CAccessEaseView::SetReadOnly(BOOL bReadOnly)
{
	m_bIsReadOnly = bReadOnly;

	CEdit * pEdit = (CEdit *)(GetDlgItem(IDC_COMBO_SITE)->GetWindow(GW_CHILD));
	pEdit->SetReadOnly(bReadOnly);
 	((CEdit *)GetDlgItem(IDC_EDIT_URL_SITE))->SetReadOnly(bReadOnly);
	((CEdit *)GetDlgItem(IDC_EDIT_USER_SITE))->SetReadOnly(bReadOnly);
	((CEdit *)GetDlgItem(IDC_EDIT_PSWD_SITE))->SetReadOnly(bReadOnly);
	((CEdit *)GetDlgItem(IDC_EDIT_NOTES_SITE))->SetReadOnly(bReadOnly);

	if(m_nIndexLastComboBoxSite >= 0) OnSelchangeComboSite();
	
	if(m_bIsReadOnly && m_nIndexLastComboBoxSite >= 0) // just left Edit or Add
	{
		CString aStr;
		CSiteInfo * pInfo = (CSiteInfo *)m_comboBoxSite.GetItemData(m_nIndexLastComboBoxSite);
		ASSERT_VALID(pInfo);
		// remove password if left on clipboard
		if(GetStrOnClipBoard(aStr) && aStr == pInfo->m_strPswdSite && OpenClipboard())
		{
			::EmptyClipboard();
 			::CloseClipboard();
		}
	}
}

void CAccessEaseView::OnHelpDoc() 
{
	CString strUrlHelp = _T("http://dickinsonian.com/programs/AccessEaseDoc.pdf#page=1&view=fitH");

	if((HINSTANCE)32 >= ::ShellExecute(m_hWnd, NULL, strUrlHelp, NULL, NULL, SW_SHOWNORMAL))
	{
		AfxMessageBox(GetLastErrorMessage() + "\n\n" + strUrlHelp,  MB_ICONWARNING);  				
	}
}

void CAccessEaseView::OnDropdownComboSite() 
{
	if(!m_bIsReadOnly || m_comboBoxSite.GetCount() == 0)
	{
		PostMessage(WM_CLOSE_DROPDOWN); // do this after all queued action takes place
	}
}

// close an attempt to pull down combo box list while editing or adding
void CAccessEaseView::CloseDropDown(WPARAM wParam, LPARAM lParam)
{
	m_comboBoxSite.ShowDropDown(FALSE);

	if(m_comboBoxSite.GetCount() > 0)
	{
		AfxMessageBox(IDS_CANT_CHANGE_SITE, MB_ICONWARNING);
	}
	else
	{
		AfxMessageBox(IDS_NO_SITES_AVAILABLE, MB_ICONWARNING);
	}
}

void CAccessEaseView::OnSelchangeComboSite() 
{
	if(m_comboBoxSite.GetCount() > 0)
	{
		int indexCombo = m_comboBoxSite.GetCurSel();
		ASSERT(CB_ERR != indexCombo);

		CSiteInfo * pInfo = (CSiteInfo *)m_comboBoxSite.GetItemData(indexCombo);
		ASSERT(pInfo);
		// get site data
		m_strUrlSite = pInfo->m_strUrlSite;
		m_strUserSite = pInfo->m_strUserSite;
		m_strPswdSite = m_bIsReadOnly ? ConvertToAsterisk(pInfo->m_strPswdSite): pInfo->m_strPswdSite;
		m_strNotesSite = pInfo->m_strNotesSite;

		// set this site as last viewed
		m_nIndexLastComboBoxSite = indexCombo;

		UpdateData(FALSE);

		// save last site to put in registry as program exits
		m_comboBoxSite.GetLBText(indexCombo, P_APP->m_strLastSiteName); 
	}
	else
	{
		m_nIndexLastComboBoxSite = -1; // indicates no sites
		OnEditCancelSite(); // clears all site data windows
	}
}

// remove gray background, clear site and data windows, and allow data entry
void CAccessEaseView::OnEditAddSite() 
{
	SetReadOnly(FALSE);
	ClearSite();
}

void CAccessEaseView::OnUpdateEditAddSite(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bIsReadOnly);	
}

void CAccessEaseView::OnButtonAddSite() 
{
	m_bIsReadOnly ? OnEditAddSite() : AfxMessageBox(IDS_KEEP_CANCEL, MB_ICONEXCLAMATION);
}

// cnacel either Edit or Add
void CAccessEaseView::OnEditCancelSite() 
{
	m_bEditingSite = FALSE;

	if(m_comboBoxSite.GetCount() > 0)
	{
		RestoreSite(m_nIndexLastComboBoxSite);	
		SetReadOnly(TRUE);
	}
	else
	{
		ClearSite();
		SetReadOnly(FALSE);
	}
}

void CAccessEaseView::OnUpdateEditCancelSite(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!m_bIsReadOnly);	
}

void CAccessEaseView::OnButtonCancelSite() 
{
	!m_bIsReadOnly ? OnEditCancelSite() : MessageBeep(0xFFFFFFFF);
}

void CAccessEaseView::OnEditEditSite() 
{
	SetReadOnly(FALSE);
	m_bEditingSite = TRUE;
}

void CAccessEaseView::OnUpdateEditEditSite(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!m_bEditingSite && m_bIsReadOnly && m_comboBoxSite.GetCount() > 0);	
}

void CAccessEaseView::OnButtonEditSite() 
{
	!m_bEditingSite && m_bIsReadOnly && m_comboBoxSite.GetCount() > 0 ? OnEditEditSite() : 
					AfxMessageBox(IDS_KEEP_CANCEL, MB_ICONEXCLAMATION);
}

void CAccessEaseView::OnEditKeepSite() 
{
	CString siteStr;
	m_comboBoxSite.GetWindowText(siteStr); // get latest string in combo edit box
	UpdateData(TRUE); // load current site data strings

	// check all data entered
	if(!siteStr.IsEmpty())
	{
		if(m_bEditingSite) // remove old site
		{
			CSiteInfo * pInfo = (CSiteInfo *)m_comboBoxSite.GetItemData(m_nIndexLastComboBoxSite);
			GetDocument()->DeleteSite(pInfo);
			m_comboBoxSite.DeleteString(m_nIndexLastComboBoxSite);
			m_bEditingSite = FALSE;
		}

		// add new site	and CSiteInfo class data
		int indexCombo = m_comboBoxSite.AddString(siteStr);
		ASSERT(indexCombo != CB_ERR && indexCombo != CB_ERRSPACE);

		// add CSiteInfo class
		CSiteInfo * pInfo = new CSiteInfo(siteStr, m_strUrlSite, m_strUserSite, m_strPswdSite, m_strNotesSite);
		ASSERT(pInfo);
		VERIFY(CB_ERR != m_comboBoxSite.SetItemData(indexCombo, (DWORD)pInfo));
		GetDocument()->m_sitePtrArray.Add(pInfo);

		// point to this site as last viewed
		m_nIndexLastComboBoxSite = indexCombo;
		m_comboBoxSite.SetCurSel(m_nIndexLastComboBoxSite);

		// done saving site
		SetReadOnly(TRUE);
		GetDocument()->SetModifiedFlag(TRUE);
	}
	else
	{
		AfxMessageBox(IDS_FILL_IN_SITE_DATA, MB_ICONWARNING);
	}
}

void CAccessEaseView::OnUpdateEditKeepSite(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!m_bIsReadOnly);	
}

void CAccessEaseView::OnButtonKeepSite() 
{
	!m_bIsReadOnly ? OnEditKeepSite() : MessageBeep(0xFFFFFFFF);	
}

void CAccessEaseView::OnEditRemoveSite() 
{
	if(IDYES == AfxMessageBox(IDS_REMOVE_SITE, MB_YESNO | MB_ICONQUESTION | MB_DEFBUTTON2))
	{
		CSiteInfo * pInfo = (CSiteInfo *)m_comboBoxSite.GetItemData(m_nIndexLastComboBoxSite);
		ASSERT_VALID(pInfo);
		GetDocument()->DeleteSite(pInfo);
		int nRemaining = m_comboBoxSite.DeleteString(m_nIndexLastComboBoxSite);
		ASSERT(CB_ERR != nRemaining);

		if(nRemaining > 0) // select site at top of list
		{
			m_nIndexLastComboBoxSite = 0;
		}
		else // no sites
		{
			m_nIndexLastComboBoxSite = -1;
			SetReadOnly(FALSE);
			ClearSite();
		}

		m_comboBoxSite.SetCurSel(m_nIndexLastComboBoxSite);
		OnSelchangeComboSite();
		GetDocument()->SetModifiedFlag(TRUE);
	}
}

void CAccessEaseView::OnUpdateEditRemoveSite(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bIsReadOnly && m_comboBoxSite.GetCount() > 0);	
}

void CAccessEaseView::OnButtonRemoveSite() 
{
	m_bIsReadOnly && m_comboBoxSite.GetCount() > 0 ? OnEditRemoveSite() : 
					 AfxMessageBox(IDS_KEEP_CANCEL, MB_ICONEXCLAMATION); 	
}

void CAccessEaseView::OnEditGoToSite() 
{
	if((HINSTANCE)32 >= ::ShellExecute(m_hWnd, NULL, m_strUrlSite, NULL, NULL, SW_SHOWNORMAL))
	{
		AfxMessageBox(GetLastErrorMessage() + "\n\n" + m_strUrlSite,  MB_ICONWARNING);  				
	}
}

void CAccessEaseView::OnUpdateEditGoToSite(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!m_strUrlSite.IsEmpty());
}

void CAccessEaseView::OnButtonGoToSite() 
{
	!m_strUrlSite.IsEmpty() ? OnEditGoToSite() : MessageBeep(0xFFFFFFFF);	
}

void CAccessEaseView::OnButtonNotesSite() 
{
	CNotesDlg7 aDlg;
	aDlg.m_bReadOnly = m_bIsReadOnly;

	// dialog title includes site name
	if(m_comboBoxSite.GetCount() > 0)
	{
		m_comboBoxSite.GetLBText(m_nIndexLastComboBoxSite, aDlg.m_titleStr);
		aDlg.m_titleStr = _T(" - ") + aDlg.m_titleStr;
	}

	aDlg.m_titleStr = _T("Notes") + aDlg.m_titleStr;

	// get string displayed in dialog
	UpdateData(TRUE);
	aDlg.m_strSiteNotes = m_strNotesSite;

	if(IDOK == aDlg.DoModal() && !m_bIsReadOnly)
	{
		m_strNotesSite = aDlg.m_strSiteNotes;
		UpdateData(FALSE);
	}
}

void CAccessEaseView::OnEditNotes() 
{
	OnButtonNotesSite();
}

// put password on clip board if it was copied as we leave this window
void CAccessEaseView::OnKillfocusEditPswdSite() 
{
	if(m_bIsReadOnly) // the password window is filled with ***** obscuring the password
	{
		CString aStr;
		GetStrOnClipBoard(aStr);
		// check if password was copied by comparing its ***** length with that in the password window
		if(aStr == m_strPswdSite)
		{
			CSiteInfo * pInfo = (CSiteInfo *)m_comboBoxSite.GetItemData(m_nIndexLastComboBoxSite);
			m_strPswdOnClipboard = pInfo->m_strPswdSite; // make copy for comparison after 5 second timeout
			PutStrOnClipBoard(m_strPswdOnClipboard, m_hWnd); // put real password on clipboard
			SetTimer(DEL_PSWD_TIMER_ID, DEL_PSWD_TIMOUT, NULL); // delete password from cliboard in 10 seconds
		}
	}
}

// delete password from clipboard
void CAccessEaseView::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent == DEL_PSWD_TIMER_ID)
	{
 		KillTimer(DEL_PSWD_TIMER_ID);

		CString aStr;

		if(GetStrOnClipBoard(aStr) && m_strPswdOnClipboard == aStr && OpenClipboard())
		{
			::EmptyClipboard();
			::CloseClipboard();
		}

		m_strPswdOnClipboard.Empty();
	}
	else
	{
		CFormView::OnTimer(nIDEvent);
	}
}

CString CAccessEaseView::ConvertToAsterisk(CString strPswd)
{
	int nLen = strPswd.GetLength();

	CString aStr(_T(""));

	for(int i = 0; i < nLen; i++)
	{
		aStr += _T("*");
	}

	return aStr;
}

void CAccessEaseView::OnEditFind() 
{
	if(m_bIsReadOnly && m_comboBoxSite.GetCount() > 0)
	{
		CFindDlg aDlg(this);
		// save for restore after cancel
		CString strFind = P_APP->m_strFind;
		int nIndexLastComboBoxSite = m_nIndexLastComboBoxSite;

		if(IDOK != aDlg.DoModal())
		{
			// restore to condition before dialog
			P_APP->m_strFind = strFind;

			if(m_nIndexLastComboBoxSite != nIndexLastComboBoxSite)
			{
				m_nIndexLastComboBoxSite = nIndexLastComboBoxSite;
				m_comboBoxSite.SetCurSel(m_nIndexLastComboBoxSite);
				OnSelchangeComboSite();
			}
		}
	}
	else
	{
		AfxMessageBox(IDS_KEEP_CANCEL, MB_ICONEXCLAMATION);
	}
}

void CAccessEaseView::OnUpdateEditFind(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bIsReadOnly && m_comboBoxSite.GetCount() > 0);	
}

void CAccessEaseView::Find(int direction, int start)
{
	int nOffset = -1;
	int index = MyFindString(P_APP->m_strFind, &nOffset, direction, start);
	
	if(index >= 0)
	{
		m_nIndexLastComboBoxSite = index;
		m_comboBoxSite.SetCurSel(m_nIndexLastComboBoxSite);
		OnSelchangeComboSite();

		// hilight found text in combobox
		CEdit * pEdit = (CEdit *)(GetDlgItem(IDC_COMBO_SITE)->GetWindow(GW_CHILD));
		pEdit->SetSel(nOffset, nOffset + P_APP->m_strFind.GetLength());
	}
	else
	{
		MessageBeep(0xFFFFFFFF);
	}
}

// returns combobox index or -1 if not found
// if found, *pOffset contains offset of start of found text
// direction is (+) for increasing ComboBox index, start is ComboBox index to start search 
int CAccessEaseView::MyFindString(CString strFind, int * pOffset, int direction, int start)
{
	int nCount = m_comboBoxSite.GetCount();

	if(!strFind.IsEmpty() && m_bIsReadOnly && nCount > 0 && m_nIndexLastComboBoxSite >= 0)
	{
		if(direction != 0) // keep in range -1, 0, +1
		{
			direction = direction / abs(direction);
		}

		CString aStr;
		strFind.MakeLower();
		int index = m_nIndexLastComboBoxSite + start; 

		for(int i = 0; i < nCount; i++)
		{
			index = (index + nCount ) % nCount; // keep in range 0 to nCoubt - 1

			m_comboBoxSite.GetLBText(index, aStr);
			aStr.MakeLower();
			ASSERT(pOffset);

			if((*pOffset = aStr.Find(strFind, 0)) >= 0)
			{
				return index;
			}

			index += direction;
		}
	}

	return -1;
}

void CAccessEaseView::OnEditCopy() 
{
	CEdit * pEdit = (CEdit *)GetFocus();

	if(pEdit)
	{
		pEdit->Copy();
	}
}

void CAccessEaseView::OnEditCut() 
{
	CEdit * pEdit = (CEdit *)GetFocus();

	if(pEdit)
	{
		pEdit->Cut();
	}
}

void CAccessEaseView::OnUpdateEditCut(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!m_bIsReadOnly);	
}

void CAccessEaseView::OnEditPaste() 
{
	CEdit * pEdit = (CEdit *)GetFocus();

	if(pEdit)
	{
		pEdit->Paste();
	}
}

void CAccessEaseView::OnUpdateEditPaste(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!m_bIsReadOnly && ::IsClipboardFormatAvailable(CF_TEXT ));	
}

void CAccessEaseView::OnEditUndo() 
{
	CEdit * pEdit = (CEdit *)GetFocus();

	if(pEdit)
	{
		pEdit->Undo();
	}
}

void CAccessEaseView::OnUpdateEditUndo(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(!m_bIsReadOnly && ::IsClipboardFormatAvailable(CF_TEXT ));	
}




