// AccessEaseView.h : interface of the CAccessEaseView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_ACCESSEASEVIEW_H__5F8A19E6_7746_46EF_8493_3868AD20F39E__INCLUDED_)
#define AFX_ACCESSEASEVIEW_H__5F8A19E6_7746_46EF_8493_3868AD20F39E__INCLUDED_

#include "MyStuff.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CAccessEaseView : public CFormView
{
protected: // create from serialization only
	CAccessEaseView();
	DECLARE_DYNCREATE(CAccessEaseView)

public:
	//{{AFX_DATA(CAccessEaseView)
	enum { IDD = IDD_ACCESSEASE_FORM };
	CComboBox	m_comboBoxSite;
	CString	m_strNotesSite;
	CString	m_strPswdSite;
	CString	m_strUrlSite;
	CString	m_strUserSite;
	//}}AFX_DATA

// Attributes
public:
	CAccessEaseDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAccessEaseView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	void Find(int direction, int start);
	int MyFindString(CString strFind, int * pOffset, int direction, int start);
	CString m_strPswdOnClipboard;
	CString ConvertToAsterisk(CString strPswd);
	BOOL m_bIsReadOnly;
	int m_nIndexLastComboBoxSite;
	void RestoreSite(int index);
	BOOL m_bEditingSite;
	void ClearSite();
	void SetReadOnly(BOOL bReadOnly);
	virtual ~CAccessEaseView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CAccessEaseView)
	afx_msg void OnHelpDoc();
	afx_msg void OnEditAddSite();
	afx_msg void OnUpdateEditAddSite(CCmdUI* pCmdUI);
	afx_msg void OnButtonAddSite();
	afx_msg void OnEditCancelSite();
	afx_msg void OnUpdateEditCancelSite(CCmdUI* pCmdUI);
	afx_msg void OnButtonCancelSite();
	afx_msg void OnEditEditSite();
	afx_msg void OnUpdateEditEditSite(CCmdUI* pCmdUI);
	afx_msg void OnButtonEditSite();
	afx_msg void OnDropdownComboSite();
	afx_msg void OnSelchangeComboSite();
	afx_msg void OnEditKeepSite();
	afx_msg void OnUpdateEditKeepSite(CCmdUI* pCmdUI);
	afx_msg void OnButtonKeepSite();
	afx_msg void OnEditRemoveSite();
	afx_msg void OnUpdateEditRemoveSite(CCmdUI* pCmdUI);
	afx_msg void OnButtonRemoveSite();
	afx_msg void OnEditGoToSite();
	afx_msg void OnUpdateEditGoToSite(CCmdUI* pCmdUI);
	afx_msg void OnButtonGoToSite();
	afx_msg void OnButtonNotesSite();
	afx_msg void OnUpdateFilePrint(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFilePrintPreview(CCmdUI* pCmdUI);
	afx_msg void OnKillfocusEditPswdSite();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnEditFind();
	afx_msg void OnUpdateEditFind(CCmdUI* pCmdUI);
	afx_msg void OnEditCopy();
	afx_msg void OnEditCut();
	afx_msg void OnUpdateEditCut(CCmdUI* pCmdUI);
	afx_msg void OnEditPaste();
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnEditUndo();
	afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
	afx_msg void OnEditNotes();
	//}}AFX_MSG
	afx_msg void OnUpdateNumSites(CCmdUI* pCmdUI);
	afx_msg void CloseDropDown(WPARAM wParam = 0, LPARAM lParam = 0);
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in AccessEaseView.cpp
inline CAccessEaseDoc* CAccessEaseView::GetDocument()
   { return (CAccessEaseDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ACCESSEASEVIEW_H__5F8A19E6_7746_46EF_8493_3868AD20F39E__INCLUDED_)
