// GenPswdDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AllMyIncludes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGenPswdDlg dialog


CGenPswdDlg::CGenPswdDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGenPswdDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGenPswdDlg)
	m_strEditPswd = _T("");
	m_nPswdLength = 0;
	m_bPswdMixedCase = FALSE;
	m_bPswdNumbers = FALSE;
	m_bPswdPuncuation = FALSE;
	//}}AFX_DATA_INIT
}


void CGenPswdDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGenPswdDlg)
	DDX_Text(pDX, IDC_EDIT_PSWD, m_strEditPswd);
	DDX_Text(pDX, IDC_PSWD_LENGTH, m_nPswdLength);
	DDX_Check(pDX, IDC_PSWD_MIXED_CASE, m_bPswdMixedCase);
	DDX_Check(pDX, IDC_PSWD_NUMBERS, m_bPswdNumbers);
	DDX_Check(pDX, IDC_PSWD_PUNCUATION, m_bPswdPuncuation);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGenPswdDlg, CDialog)
	//{{AFX_MSG_MAP(CGenPswdDlg)
	ON_BN_CLICKED(IDC_BUTTON_PSWD_CREATE, OnButtonPswdCreate)
	ON_BN_CLICKED(IDC_BUTTON_100_PSWDS, OnButton100Pswds)
	ON_WM_DESTROY()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGenPswdDlg message handlers

BOOL CGenPswdDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_nPswdLength = P_APP->m_nPswdLength;
	m_bPswdMixedCase = P_APP->m_bPswdMixedCase;
	m_bPswdNumbers = P_APP->m_bPswdNumbers;
	m_bPswdPuncuation = P_APP->m_bPswdPuncuation;
	UpdateData(FALSE);
	
	// locate dialog at upper left of view window just below title bar
	CRect frameRect;
	P_FRAME->GetWindowRect(&frameRect);
	CRect dlgRect;
	GetWindowRect(&dlgRect);

	int x = frameRect.right - dlgRect.Width();
	int y = frameRect.top + GetSystemMetrics(SM_CYCAPTION);

	WINDOWPLACEMENT wp;
	GetWindowPlacement(&wp);
	SetWindowPos(NULL, x, y, ((CRect)wp.rcNormalPosition).Width(), ((CRect)wp.rcNormalPosition).Height(), SWP_NOZORDER);

    // add icon to dialog
	HICON hicon = P_APP->LoadIcon(IDR_MAINFRAME);
	ASSERT(hicon);
	SetIcon(hicon, TRUE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CGenPswdDlg::OnButtonPswdCreate() 
{
	UpdateData(TRUE);

	CString aStr(_lowerCase); // all password have lower case

	if(m_bPswdMixedCase) aStr += _upperCase;

	if(m_bPswdNumbers) aStr += _numbers;

	if(m_bPswdPuncuation) aStr += _puncuation;

	int len = aStr.GetLength(); 

	m_strEditPswd.Empty();

	for(UINT i = 0; i < m_nPswdLength; i++)
	{
		UINT offset = (::rand() * len) / RAND_MAX;
		m_strEditPswd += aStr.GetAt(offset);
	}

	UpdateData(FALSE);
}

void CGenPswdDlg::OnButton100Pswds() 
{
	CString aStr(_lowerCase); // all password have lower case

	if(m_bPswdMixedCase) aStr += _upperCase;

	if(m_bPswdNumbers) aStr += _numbers;

	if(m_bPswdPuncuation) aStr += _puncuation;

	int len = aStr.GetLength(); 

	m_strEditPswd.Empty();

	CString bStr;

	for(int i = 0; i < 100; i++)
	{
		for(UINT i = 0; i < m_nPswdLength; i++)
		{
			UINT offset = (::rand() * len) / RAND_MAX;
			bStr += aStr.GetAt(offset);
		}

		bStr += _T("\r\n");
	}

	PutStrOnClipBoard(bStr);
}

void CGenPswdDlg::OnDestroy() 
{
	UpdateData(TRUE);
	P_APP->m_nPswdLength = m_nPswdLength;
	P_APP->m_bPswdMixedCase = m_bPswdMixedCase;
	P_APP->m_bPswdNumbers = m_bPswdNumbers;
	P_APP->m_bPswdPuncuation = m_bPswdPuncuation;
	
	CDialog::OnDestroy();
}

void CGenPswdDlg::PostNcDestroy() 
{
	CDialog::PostNcDestroy();

	P_FRAME->m_pGenPswdDlg = NULL;
	delete this;
}

void CGenPswdDlg::OnCancel() 
{
// [esc] key press ignore
}

void CGenPswdDlg::OnClose() 
{
	DestroyWindow();
}
