// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "AllMyIncludes.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_CLOSE()
	ON_WM_ENDSESSION()
	ON_COMMAND(ID_GEN_PSWD, OnGenPswd)
	ON_UPDATE_COMMAND_UI(ID_GEN_PSWD, OnUpdateGenPswd)
	ON_COMMAND(ID_EDIT_NOTES, OnEditNotes)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_SITES,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_nActivateCnt = 0;
	m_pGenPswdDlg = NULL;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators, 
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style &= ~WS_MAXIMIZEBOX; // remove mamimize box

	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

// get window position, size and if iconized from registry at startup
void CMainFrame::ActivateFrame(int nCmdShow) 
{
	if(m_nActivateCnt < 2) // preevent each time a new file is loaded, jost on startup
	{
		m_nActivateCnt++;
		CString strText; // main window position
		strText = AfxGetApp()->GetProfileString(_mainWindow, _rect, NULL);

		CRect rect(0, 0, 0, 0);

		// get window position from registry
		if (!strText.IsEmpty() && 4 == sscanf(strText, _T("%d %d %d %d"), &rect.left, &rect.top, &rect.right, &rect.bottom)) 
		{
			BOOL bMaximized = AfxGetApp()->GetProfileInt(_mainWindow, _max, 0); 
			UINT flags = bMaximized ? WPF_RESTORETOMAXIMIZED : WPF_SETMINPOSITION;

			BOOL bIconic = AfxGetApp()->GetProfileInt(_mainWindow, _icon, 0);
			if (bIconic) 
			{
				nCmdShow = SW_SHOWMINNOACTIVE;
			}
			else
			{
				nCmdShow = bMaximized ? SW_SHOWMAXIMIZED : SW_NORMAL;
			}

			WINDOWPLACEMENT wndpl;
			wndpl.length = sizeof(WINDOWPLACEMENT);
			wndpl.showCmd = nCmdShow;
			wndpl.flags = flags;
			wndpl.ptMinPosition = CPoint(0, 0);
			wndpl.ptMaxPosition = CPoint(-::GetSystemMetrics(SM_CXBORDER), -::GetSystemMetrics(SM_CYBORDER));
			wndpl.rcNormalPosition = rect;
			LoadBarState(AfxGetApp()->m_pszProfileName);
			// sets window's position and minimized/maximized status
			SetWindowPlacement(&wndpl);

			return;
		}
	}
		
	CFrameWnd::ActivateFrame(nCmdShow);
}

// save window position, sice and if iconized to registry on exit
void CMainFrame::OnDestroy() 
{
	CString strText;
	BOOL bIconic, bMaximized;

	WINDOWPLACEMENT wndpl;
	wndpl.length = sizeof(WINDOWPLACEMENT);
	// gets current window position and
	//  iconized/maximized status
	BOOL bRet = GetWindowPlacement(&wndpl);
	if (wndpl.showCmd == SW_SHOWNORMAL) 
	{
		bIconic = FALSE;
		bMaximized = FALSE;
	}
	else if (wndpl.showCmd == SW_SHOWMAXIMIZED) 
	{
		bIconic = FALSE;
		bMaximized = TRUE;
	} 
	else if (wndpl.showCmd == SW_SHOWMINIMIZED) 
	{
		bIconic = TRUE;
		if (wndpl.flags) 
		{
			bMaximized = TRUE;
		}
		else 
		{
			bMaximized = FALSE;
		}
	}
	// main window location
	strText.Format("%04d %04d %04d %04d",
	               wndpl.rcNormalPosition.left,
	               wndpl.rcNormalPosition.top,
	               wndpl.rcNormalPosition.right,
	               wndpl.rcNormalPosition.bottom);

	AfxGetApp()->WriteProfileString(_mainWindow, _rect, strText);
	AfxGetApp()->WriteProfileInt(_mainWindow, _icon, bIconic);
	AfxGetApp()->WriteProfileInt(_mainWindow, _max, bMaximized);

	SaveBarState(AfxGetApp()->m_pszProfileName);

	CFrameWnd::OnDestroy();
}

void CMainFrame::OnClose() 
{
	CAccessEaseView * pView = (CAccessEaseView *)GetActiveView();
	ASSERT_VALID(pView);

	if(pView->m_comboBoxSite.GetCount() > 0 && !pView->m_bIsReadOnly)
	{
		AfxMessageBox(IDS_KEEP_CANCEL, MB_ICONEXCLAMATION);
	}
	else
	{	
		CFrameWnd::OnClose();
	}	
}

void CMainFrame::OnGenPswd() 
{
	m_pGenPswdDlg = new	CGenPswdDlg;
	m_pGenPswdDlg->Create(IDD_GEN_PSWD_DLG, this);
	m_pGenPswdDlg->ShowWindow(SW_SHOW);	
}

void CMainFrame::OnUpdateGenPswd(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pGenPswdDlg == NULL);	
}


void CMainFrame::OnEditNotes() 
{
	// TODO: Add your command handler code here
	
}

// windows is shutting down, save a modified document
void CMainFrame::OnEndSession(BOOL bEnding) 
{
	if(bEnding)
	{
		CAccessEaseDoc * pDoc = (CAccessEaseDoc *)(GetActiveView()->GetDocument());
		pDoc->OnSaveDocument(pDoc->GetPathName());
	}

	CFrameWnd::OnEndSession(bEnding);	
}

