#include "stdafx.h"
#include "AllMyIncludes.h"

CString encode(CString strPswd, CString strData)
{
	if(!strPswd.IsEmpty())
	{
		UINT nPswd = strPswd.GetLength();
		UINT nData = strData.GetLength();
		UCHAR * pPswd = (UCHAR *)strPswd.GetBuffer(nPswd);
		UCHAR * pData = (UCHAR *)strData.GetBuffer(nData);

		for(UINT i =0, k = 0; i < nData; i++, k = i % nPswd)
		{
			UINT shift = bitsInByte[pPswd[k]];
			pData[i] = (pData[i] << shift) | (pData[i] >> (8 - shift));
		}

		strPswd.ReleaseBuffer();
		strData.ReleaseBuffer();
	}

	return strData;
}

CString decode(CString strPswd, CString strData)
{
	if(!strPswd.IsEmpty())
	{
		UINT nPswd = strPswd.GetLength();
		UINT nData = strData.GetLength();
		UCHAR * pPswd = (UCHAR *)strPswd.GetBuffer(nPswd);
		UCHAR * pData = (UCHAR *)strData.GetBuffer(nData);

		for(UINT i =0, k = 0; i < nData; i++, k = i % nPswd)
		{
			UINT shift = bitsInByte[pPswd[k]];
			pData[i] = (pData[i] >> shift) | (pData[i] << (8 - shift));
		}

		strPswd.ReleaseBuffer();
		strData.ReleaseBuffer();
	}

	return strData;
}

// CSiteInfo implimentation

void CSiteInfo::Serialize(CArchive & ar)
{
	CObject::Serialize(ar);

	CString strEncryptionPswd = P_APP->m_strEncryptionPswd;

	if(ar.IsStoring())
	{
		ar << encode(strEncryptionPswd, m_strSite);
		ar << encode(strEncryptionPswd, m_strUrlSite);
		ar << encode(strEncryptionPswd, m_strUserSite);
		ar << encode(strEncryptionPswd, m_strPswdSite);
		ar << encode(strEncryptionPswd, m_strNotesSite);
	}
	else // retrieving
	{
		CString aStr;

		ar >> aStr; m_strSite = decode(strEncryptionPswd, aStr); 
		ar >> aStr; m_strUrlSite = decode(strEncryptionPswd, aStr); 
		ar >> aStr; m_strUserSite = decode(strEncryptionPswd, aStr); 
		ar >> aStr;	m_strPswdSite = decode(strEncryptionPswd, aStr); 
		ar >> aStr;	m_strNotesSite = decode(strEncryptionPswd, aStr); 
	}
}

IMPLEMENT_SERIAL (CSiteInfo, CObject, 1)

BOOL GetStrOnClipBoard(CString & strClipBoard)
{
 	BOOL bRetVal = FALSE;

	if(::OpenClipboard(NULL))	// copy to clipboard as aa text string
	{
		HANDLE hData = ::GetClipboardData(CF_TEXT);

		if(hData)
		{
		   LPCSTR pData = (LPCSTR)::GlobalLock(hData);
		   ASSERT(pData);
		   int nLen = lstrlen(pData);

		   strClipBoard = pData;
		   ::GlobalUnlock(hData);
		   bRetVal = TRUE;
		}

		::CloseClipboard();
	}

	return bRetVal;
}

BOOL PutStrOnClipBoard(CString & aStr, HWND hWnd)	// overload on following proceedure using char *
{
	char * cBuf = aStr.GetBuffer(aStr.GetLength() + 1);

	BOOL bRet = PutStrOnClipBoard(cBuf, hWnd);

	aStr.ReleaseBuffer(-1);

	return bRet;
}

BOOL PutStrOnClipBoard(char * cBuf, HWND hWnd)
{
	if(::OpenClipboard(hWnd))	// copy to clipboard as aa text string
	{
		UINT len = ::strlen(cBuf) + 1;

		::EmptyClipboard();
		HANDLE hData = ::GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, len);
		LPSTR pData = (LPSTR)::GlobalLock(hData);

		::CopyMemory(pData, cBuf, len);
		::GlobalUnlock(hData);
		::SetClipboardData(CF_TEXT, hData);
		::CloseClipboard();
		return TRUE;
	}

	return FALSE;
}

time_t FileTimeToTimet(LPFILETIME pft)
{
	LONGLONG ll = (((LONGLONG)pft->dwHighDateTime) << 32) + ((LONGLONG)pft->dwLowDateTime);
	return (time_t)((ll - (LONGLONG)116444736000000000) / (LONGLONG)10000000);	
}

#include <Wininet.h>
CString GetLastErrorMessage()
{
	DWORD nErr = GetLastError();
	CString msgStr;

	if(nErr == ERROR_INTERNET_EXTENDED_ERROR)
	{
		DWORD dwError;
		char szBuffer[1024];
		DWORD dwBufferLength = sizeof(szBuffer);

		if(InternetGetLastResponseInfo(&dwError, szBuffer, &dwBufferLength))
		{
			 msgStr = szBuffer;
		}
	}
	else
	{
		LPVOID lpMsgBuf;

		FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			nErr,
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL 
		);

		msgStr = (LPCTSTR)lpMsgBuf;
		LocalFree(lpMsgBuf);
	}

	msgStr.TrimRight(); // remove CR-LF
	msgStr.TrimLeft();

	if(msgStr.IsEmpty())
	{
		msgStr.Format(_T("Last Error = %d"), nErr);
	}

	return msgStr;
}
