#ifndef MY_STUFF_H
#define MY_STUFF_H

// registry key names
char const _settings[]		= _T("settings");
char const _bMixedCase[]	= _T("bMixedCase");
char const _bNumbers[]		= _T("bNumbers");
char const _bPuncuation[]	= _T("bPuncuation");
char const _bOpenMRU[]		= _T("bOpenMRU");
char const _nLength[]		= _T("nLength");
char const _strSiteName[]	= _T("strSiteName");
char const _bHidePswd[]		= _T("bHidePswd");
char const _strFind[]		= _T("strFind");

// registry main window position
char const _mainWindow[]	= "mainWindow";
char const _rect[]			= "rect";
char const _icon[]			= "icon";
char const _max[]			= "max";

// printer
#define LEFT_MARGIN_INCH 0.75
#define TOP_MARGIN_INCH 0.75
#define PRINT_PT_SIZE 12
char const _printFaceName[] = _T("Arial");
char const _tabReplace[]	= _T("        ");

// documentation
char const _documentationFile[] = _T("AccessEaseDoc.pdf");
// program constants
char const _strPgmId[] = _T("AccessEase Version 1.0");
char const _strIndicator[] = _T(" *");
// defines
#define DFLT_PSWD_LEN 8
#define MIN_PSWD_LEN 5
#define MAX_PSWD_LEN 20
#define WM_CLOSE_DROPDOWN (WM_USER + 5)

//email
#define MY_EMAIL_URL "dick@dickinsonian.com"
#define SUBJECT "?subject=Concerning your program AccessEase"
#define MAIL2 "mailto:"

// macros
#define P_VIEW ((CAccessEaseView *)m_viewList.GetHead()) // access to view from document
#define P_APP ((CAccessEaseApp *)AfxGetApp()) // access to app form anywhere
#define P_FRAME ((CMainFrame *)AfxGetMainWnd()) // access to mainframe from anywhere

// password creation
char const _numbers[] = _T("0123456789");
char const _puncuation[] = _T("!@#$%&*?+-=_");
char const _lowerCase[] = _T("abcdefghijklmnopqrstuvwxyz");
char const _upperCase[] = _T("ABCDEFGHIJKLMNOPQRSTUVWXYZ");
#define DEL_PSWD_TIMER_ID 1
#define DEL_PSWD_TIMOUT 10000 // milliseconds 10 seconds

// file encryption
CString encode(CString strPswd, CString strData);
CString decode(CString strPswd, CString strData);

UINT const bitsInByte[] = {
0, 1, 1, 2, 1, 2, 2, 3, 1, 2, 2, 3, 2, 3, 3, 4, 
1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5, 
1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5, 
2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 
1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5, 
2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 
2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 
3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7, 
1, 2, 2, 3, 2, 3, 3, 4, 2, 3, 3, 4, 3, 4, 4, 5, 
2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 
2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 
3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7, 
2, 3, 3, 4, 3, 4, 4, 5, 3, 4, 4, 5, 4, 5, 5, 6, 
3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7, 
3, 4, 4, 5, 4, 5, 5, 6, 4, 5, 5, 6, 5, 6, 6, 7, 
4, 5, 5, 6, 5, 6, 6, 7, 5, 6, 6, 7, 6, 7, 7, 8}; 

class CSiteInfo : public CObject
{
	DECLARE_SERIAL(CSiteInfo)
		
public:
	CString m_strSite;
	CString m_strUrlSite;
	CString m_strUserSite;
	CString m_strPswdSite;
	CString m_strNotesSite;

	CSiteInfo() {} // default constructor
	CSiteInfo(CString strSite, // load data constructor 
			  CString strUrlSite = _T(""), 
			  CString strUserSite = _T(""), 
			  CString strPswdSite = _T(""), 
			  CString strNotesSite = _T(""))
	{m_strSite = strSite; 
	 m_strUrlSite = strUrlSite; 
	 m_strUserSite = strUserSite;
	 m_strPswdSite = strPswdSite; 
	 m_strNotesSite = strNotesSite;}

	void Serialize(CArchive & ar);
};

// prototypes
BOOL PutStrOnClipBoard(char * cBuf, HWND hWnd = NULL);
BOOL PutStrOnClipBoard(CString & aStr, HWND hWnd = NULL);	// overload on following proceedure using char *
time_t FileTimeToTimet(LPFILETIME pft);
CString GetLastErrorMessage();
BOOL GetStrOnClipBoard(CString & strClipBoard);
#endif